<?php
class Payment {
	const SECURE_HASH_CORRECT = 0;
	const SECURE_HASH_INVALID = 1;
	const SECURE_SECRET_EMPTY = -1;
	private $secureSecret;
	private $virtualPaymentClientURL;
	private $isValidSecureHash;
	private $isEmptySecureSecret;
	
	public function setSecureSecret($secureSecret) {
		$this->secureSecret = $secureSecret;
	}
	
	public function setVirtualPaymentUrl($url) {
		$this->virtualPaymentClientURL = $url;
	}
	
	public function getParameter($name) {
		$data = isset($_GET[$name]) ? $_GET[$name] : (isset($HTTP_GET_VARS[$name]) ? $HTTP_GET_VARS[$name] : null);
	    if ($data == null || $data == "") {
	        return "No Value Returned";
	    } else {
	        return $data;
	    }
	}

	// Tạo secure_hash từ các tham số nhận được
	// Thuật toán mã hóa SHA256
	public function getSecureHash($parameters){
		$secureSecret = $this->secureSecret;

		$VerifyString = '';
		unset($parameters['secure_hash']);
		ksort($parameters);
		foreach($parameters as $key => $value) {

			if (strlen($value) > 0) {
				$VerifyString .= $value.'|';
				$vpcRedirect .= '&' . $key . "=" . $value;
			}
		}

		$VerifyString = $secureSecret. "|" . $VerifyString;
		// xóa bỏ ký tự "|" ở cuối chuỗi
		$VerifyString = substr($VerifyString,0,-1);

		$secure_hash = '';
		if (strlen($this->secureSecret) > 0) {
			// security_hash = HEX(SHA256(security_secret + “|” + VerifyString))
			$secure_hash = hash('sha256', $VerifyString);
		}

		return $secure_hash ;
	}
	
	// Truyền dữ liệu sang cổng thanh toán Ví Việt
	// Tham số + secure_hash
	public function redirect($parameters) {

		$virtualPaymentClientURL = $this->virtualPaymentClientURL . "?";
		$secureSecret = $this->secureSecret;

		$vpcRedirect = $virtualPaymentClientURL;
		ksort($parameters);
		foreach($parameters as $key => $value) {
			if (strlen($value) > 0) {
				$vpcRedirect .= '&' . $key . "=" . $value;
			}
		}

		$secure_hash = $this->getSecureHash($parameters);
		$url_redirect = $vpcRedirect."&secure_hash=".$secure_hash;
		
		header("Location: ".$url_redirect);
	}
	
	// Tạo secure_hash từ các tham số nhận được đem so sánh với mã secure_hash từ Ví Việt trả về đảm bảo tính toàn vẹn dữ liệu
	public function checkSum($parameters) {
		$txn_Secure_Hash = $this->getParameter("secure_hash");
		$secureSecret = $this->secureSecret;

		if (strlen($secureSecret) > 0) {
			$secure_hash = $this->getSecureHash($parameters);

		    if ($txn_Secure_Hash == $secure_hash) {
		        // Secure Hash validation succeeded, add a data field to be displayed later.
		        $this->isValidSecureHash = true;
		    } else {
		        // Secure Hash validation failed, add a data field to be displayed later.
		        $this->isValidSecureHash = false;
		    }
		} else {
		    // Secure Hash was not validated, add a data field to be displayed later.
		    $this->isEmptySecureSecret = true;
		}
	}
	
	public function isEmptySecureSecret() {
		return $this->isEmptySecureSecret;
	}
	
	public function isValidSecureHash() {
		return $this->isValidSecureHash;
	}
	
	function getResponseDescription($responseCode) {
	    switch ($responseCode) {
	        case "0" : $result = "Giao dịch thanh toán thành công"; break;
	        case "1" : $result = "Giao dịch thanh toán không thành công"; break;
	    }
	    return $result;
	}
}
?>